commit e60e2d4bc01c0a6dfc410f7659b2ec5362aa42a1
Author: freddy77 <freddy77>
Date:   Tue Nov 4 10:59:02 2008 +0000

    introduced new CHK* macros and use them

diff --git a/ChangeLog b/ChangeLog
index 4045ec0..3df21ec 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,38 @@
+Tue Nov 04 11:56:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/array_out.c src/odbc/unittests/binary_test.c:
+	* src/odbc/unittests/blob1.c src/odbc/unittests/cancel.c:
+	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
+	* src/odbc/unittests/compute.c src/odbc/unittests/connect.c:
+	* src/odbc/unittests/connect2.c src/odbc/unittests/const_params.c:
+	* src/odbc/unittests/convert_error.c src/odbc/unittests/copydesc.c:
+	* src/odbc/unittests/cursor1.c src/odbc/unittests/cursor2.c:
+	* src/odbc/unittests/cursor3.c src/odbc/unittests/cursor4.c:
+	* src/odbc/unittests/cursor5.c src/odbc/unittests/cursor6.c:
+	* src/odbc/unittests/cursor7.c src/odbc/unittests/data.c:
+	* src/odbc/unittests/date.c src/odbc/unittests/describecol.c:
+	* src/odbc/unittests/error.c src/odbc/unittests/freeclose.c:
+	* src/odbc/unittests/funccall.c src/odbc/unittests/genparams.c:
+	* src/odbc/unittests/getdata.c src/odbc/unittests/hidden.c:
+	* src/odbc/unittests/insert_speed.c src/odbc/unittests/lang_error.c:
+	* src/odbc/unittests/moreandcount.c src/odbc/unittests/norowset.c:
+	* src/odbc/unittests/paramcore.c src/odbc/unittests/params.c:
+	* src/odbc/unittests/prepare_results.c src/odbc/unittests/prepclose.c:
+	* src/odbc/unittests/preperror.c src/odbc/unittests/print.c:
+	* src/odbc/unittests/putdata.c src/odbc/unittests/raiserror.c:
+	* src/odbc/unittests/rebindpar.c src/odbc/unittests/rownumber.c:
+	* src/odbc/unittests/rowset.c src/odbc/unittests/rpc.c:
+	* src/odbc/unittests/scroll.c src/odbc/unittests/t0001.c:
+	* src/odbc/unittests/t0002.c src/odbc/unittests/t0003.c:
+	* src/odbc/unittests/t0004.c src/odbc/unittests/tables.c:
+	* src/odbc/unittests/test64.c src/odbc/unittests/testodbc.c:
+	* src/odbc/unittests/timeout.c src/odbc/unittests/timeout2.c:
+	* src/odbc/unittests/timeout3.c src/odbc/unittests/timeout4.c:
+	* src/odbc/unittests/transaction.c src/odbc/unittests/transaction2.c:
+	* src/odbc/unittests/typeinfo.c src/odbc/unittests/utf8.c:
+	* src/odbc/unittests/utf8_2.c src/odbc/unittests/warning.c:
+	* src/odbc/unittests/wchar.c:
+	- introduced new CHK* macros and use them
+
 Fri Oct 31 15:35:00 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/cursor1.c src/odbc/unittests/cursor5.c:
 	* src/odbc/unittests/utf8.c src/odbc/unittests/utf8_2.c:
@@ -813,4 +848,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2646 2008/10/31 14:35:23 freddy77 Exp $
+$Id: ChangeLog,v 1.2647 2008/11/04 10:59:02 freddy77 Exp $
diff --git a/src/odbc/unittests/array_out.c b/src/odbc/unittests/array_out.c
index 1bbb852..5117d65 100644
--- a/src/odbc/unittests/array_out.c
+++ b/src/odbc/unittests/array_out.c
@@ -3,7 +3,7 @@
 
 /* Test using array binding */
 
-static char software_version[] = "$Id: array_out.c,v 1.12 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: array_out.c,v 1.13 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char *test_query = NULL;
@@ -74,7 +74,7 @@ query_test(SQLRETURN expected, const char *expected_status)
 	SQLBindCol(Statement, 1, SQL_C_ULONG, &IDS(0), 0, &ID_LENS(0));
 	SQLBindCol(Statement, 2, SQL_C_CHAR, DESCS(0), desc_len, &DESC_LENS(0));
 
-	CHK(SQLExecDirect, (Statement, (SQLCHAR *) test_query, SQL_NTS));
+	CHKExecDirect((SQLCHAR *) test_query, SQL_NTS, "S");
 
 	ret = SQLFetch(Statement);
 	if (ret != expected)
diff --git a/src/odbc/unittests/binary_test.c b/src/odbc/unittests/binary_test.c
index ddb4911..f32e0b9 100644
--- a/src/odbc/unittests/binary_test.c
+++ b/src/odbc/unittests/binary_test.c
@@ -7,7 +7,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: binary_test.c,v 1.6 2007/10/16 15:12:22 freddy77 Exp $";
+static char software_version[] = "$Id: binary_test.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define ERR_BUF_SIZE 256
@@ -24,38 +24,12 @@ static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 #define TEST_BUF_LEN (1024*128)
 
 
-static SQLRETURN err;
 static unsigned char *buf;
 
-static int
-sqlreturn_noerr(SQLRETURN rv)
-{
-	return (rv == SQL_SUCCESS || rv == SQL_SUCCESS_WITH_INFO || rv == SQL_NO_DATA || rv == SQL_NEED_DATA);
-}
-
-/* return pointer to ODBC error string: caller owns storage */
-static const char *
-get_odbc_error(SQLHSTMT stmt_handle)
-{
-	SQLCHAR *error_buf = (SQLCHAR *) malloc(ERR_BUF_SIZE + 1);
-	SQLCHAR sql_state[100];
-	SQLINTEGER native_error;
-	SQLSMALLINT len;
-
-	err = SQLError(Environment, Connection, stmt_handle, sql_state, &native_error, error_buf, ERR_BUF_SIZE, &len);
-
-	assert(err != SQL_ERROR);
-
-	if (err == SQL_NO_DATA) {
-		strncpy((char *) error_buf, "(could not obtain error string)", ERR_BUF_SIZE);
-	}
-	return (const char *) error_buf;
-}
-
 static void
-show_error(const char *where, const char *what, int no)
+show_error(const char *where, const char *what)
 {
-	printf("ERROR in %s: %s [%d].\n", where, what, no);
+	printf("ERROR in %s: %s.\n", where, what);
 }
 
 static void
@@ -68,7 +42,7 @@ clean_up(void)
 static int
 test_insert(void *buf, SQLLEN buflen)
 {
-	SQLHSTMT stmt_handle;
+	SQLHSTMT old_Statement;
 	SQLLEN strlen_or_ind;
 	const char *qstr = "insert into " TEST_TABLE_NAME " values (?)";
 
@@ -76,46 +50,24 @@ test_insert(void *buf, SQLLEN buflen)
 	assert(Environment);
 
 	/* allocate new statement handle */
-	err = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &stmt_handle);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_insert(): allocating new statement handle", get_odbc_error(0), err);
-		return -1;
-	}
+	old_Statement = Statement;
+	Statement = SQL_NULL_HSTMT;
+	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &Statement, "SI");
 
 	/* execute query */
-	err = SQLPrepare(stmt_handle, (SQLCHAR *) qstr, SQL_NTS);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_insert(): preparing statement", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKPrepare((SQLCHAR *) qstr, SQL_NTS, "SI");
 
 	strlen_or_ind = buflen;
-	err = SQLBindParameter(stmt_handle,
-			       1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, (SQLUINTEGER) (-1), 0, buf, buflen,
-			       &strlen_or_ind);
-
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_insert(): binding to parameter", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, (SQLUINTEGER) (-1), 0, buf, buflen,
+			       &strlen_or_ind, "SI");
 
-	err = SQLExecute(stmt_handle);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_insert(): executing prepared query", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKExecute("SI");
 
 	/* this command shouldn't fail */
-	Command(stmt_handle, "DECLARE @i INT");
+	Command(Statement, "DECLARE @i INT");
 
-	SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-	stmt_handle = 0;
+	SQLFreeHandle(SQL_HANDLE_STMT, Statement);
+	Statement = old_Statement;
 	return 0;
 }
 
@@ -123,7 +75,7 @@ test_insert(void *buf, SQLLEN buflen)
 static int
 test_select(void *buf, SQLINTEGER buflen, SQLLEN * bytes_returned)
 {
-	SQLHSTMT stmt_handle;
+	SQLHSTMT old_Statement;
 	SQLLEN strlen_or_ind = 0;
 	const char *qstr = "select * from " TEST_TABLE_NAME;
 
@@ -131,54 +83,26 @@ test_select(void *buf, SQLINTEGER buflen, SQLLEN * bytes_returned)
 	assert(Environment);
 
 	/* allocate new statement handle */
-	err = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &stmt_handle);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_select(): allocating new statement handle", get_odbc_error(0), err);
-		return -1;
-	}
+	old_Statement = Statement;
+	Statement = SQL_NULL_HSTMT;
+	CHKAllocHandle(SQL_HANDLE_STMT, Connection, &Statement, "SI");
 
 	/* execute query */
-	err = SQLExecDirect(stmt_handle, (SQLCHAR *) qstr, SQL_NTS);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_select(): executing query", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKExecDirect((SQLCHAR *) qstr, SQL_NTS, "SINo");
 
 	/* fetch first page of first result row of unbound column */
-	err = SQLFetch(stmt_handle);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_select(): fetching results", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKFetch("S");
 
 	strlen_or_ind = 0;
-	err = SQLGetData(stmt_handle, 1, SQL_C_BINARY, buf, buflen, &strlen_or_ind);
-	if (!sqlreturn_noerr(err)) {
-		show_error("test_select(): getting column", get_odbc_error(stmt_handle), err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKGetData(1, SQL_C_BINARY, buf, buflen, &strlen_or_ind, "SINo");
 
 	*bytes_returned = ((strlen_or_ind > buflen || (strlen_or_ind == SQL_NO_TOTAL)) ? buflen : strlen_or_ind);
 
 	/* ensure that this was the only row */
-	err = SQLFetch(stmt_handle);
-	if (err != SQL_NO_DATA) {
-		show_error("test_select(): retrieving results",
-			   "Number of result rows must be exactly equal to 1.\n"
-			   "Please delete all entries from table '" TEST_TABLE_NAME "' and rerun test.", err);
-		SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-		stmt_handle = 0;
-		return -1;
-	}
+	CHKFetch("No");
 
-	SQLFreeHandle(SQL_HANDLE_STMT, stmt_handle);
-	stmt_handle = 0;
+	SQLFreeHandle(SQL_HANDLE_STMT, Statement);
+	Statement = old_Statement;
 	return 0;
 }
 
@@ -219,7 +143,7 @@ main(int argc, char **argv)
 
 	/* compare inserted and read back test patterns */
 	if (bytes_returned != TEST_BUF_LEN) {
-		show_error("main(): comparing buffers", "Mismatch in input and output pattern sizes.", 0);
+		show_error("main(): comparing buffers", "Mismatch in input and output pattern sizes.");
 		clean_up();
 		return -1;
 	}
@@ -227,7 +151,7 @@ main(int argc, char **argv)
 	for (i = 0; i < TEST_BUF_LEN; ++i) {
 		if (buf[i] != BYTE_AT(i)) {
 			printf("mismatch at pos %d %d != %d\n", i, buf[i], BYTE_AT(i));
-			show_error("main(): comparing buffers", "Mismatch in input and output patterns.", 0);
+			show_error("main(): comparing buffers", "Mismatch in input and output patterns.");
 			clean_up();
 			return -1;
 		}
diff --git a/src/odbc/unittests/blob1.c b/src/odbc/unittests/blob1.c
index eccf5d4..eea40ee 100755
--- a/src/odbc/unittests/blob1.c
+++ b/src/odbc/unittests/blob1.c
@@ -3,12 +3,12 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: blob1.c,v 1.9 2008/10/17 12:21:10 freddy77 Exp $";
+static char software_version[] = "$Id: blob1.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHECK_RCODE(t,h,m) \
-   if ( rcode != SQL_SUCCESS && rcode != SQL_SUCCESS_WITH_INFO && rcode != SQL_NO_DATA && rcode != SQL_NEED_DATA ) { \
-      fprintf(stderr,"Error %d at: %s\n",rcode,m); \
+   if ( RetCode != SQL_SUCCESS && RetCode != SQL_SUCCESS_WITH_INFO && RetCode != SQL_NO_DATA && RetCode != SQL_NEED_DATA ) { \
+      fprintf(stderr,"Error %d at: %s\n",RetCode,m); \
       getErrorInfo(t,h); \
       exit(1); \
    }
@@ -20,13 +20,12 @@ static int failed = 0;
 static void
 getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
 {
-	SQLRETURN rcode = 0;
 	SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
 	SQLINTEGER naterror = 0;
 	SQLCHAR msgtext[SQL_MAX_MESSAGE_LENGTH + 1];
 	SQLSMALLINT msgtextl = 0;
 
-	rcode = SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
+	SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
 			      (SQLHANDLE) sqlhandle,
 			      (SQLSMALLINT) 1,
 			      (SQLCHAR *) sqlstate,
@@ -85,9 +84,9 @@ check_hex(const char *buf, size_t len, unsigned int start, unsigned int step)
 }
 
 static int
-readBlob(SQLHSTMT * stmth, SQLUSMALLINT pos)
+readBlob(SQLUSMALLINT pos)
 {
-	SQLRETURN rcode;
+	SQLRETURN RetCode;
 	char buf[4096];
 	SQLLEN len, total = 0;
 	int i = 0;
@@ -96,8 +95,8 @@ readBlob(SQLHSTMT * stmth, SQLUSMALLINT pos)
 	printf(">> readBlob field %d\n", pos);
 	while (1) {
 		i++;
-		rcode = SQLGetData(stmth, pos, SQL_C_BINARY, (SQLPOINTER) buf, (SQLINTEGER) sizeof(buf), &len);
-		if (!SQL_SUCCEEDED(rcode) || len <= 0)
+		CHKGetData(pos, SQL_C_BINARY, (SQLPOINTER) buf, (SQLINTEGER) sizeof(buf), &len, "SINo");
+		if (RetCode == SQL_NO_DATA || len <= 0)
 			break;
 		if (len > (SQLLEN) sizeof(buf))
 			len = (SQLLEN) sizeof(buf);
@@ -115,13 +114,13 @@ readBlob(SQLHSTMT * stmth, SQLUSMALLINT pos)
 	printf(">>   total bytes read = %d \n", (int) total);
 	if (total != 10000)
 		failed = 1;
-	return rcode;
+	return RetCode;
 }
 
 static int
-readBlobAsChar(SQLHSTMT * stmth, SQLUSMALLINT pos, int step)
+readBlobAsChar(SQLUSMALLINT pos, int step)
 {
-	SQLRETURN rcode = SQL_SUCCESS_WITH_INFO;
+	SQLRETURN RetCode = SQL_SUCCESS_WITH_INFO;
 	char buf[8192];
 	SQLLEN len, total = 0;
 	int i = 0;
@@ -132,10 +131,10 @@ readBlobAsChar(SQLHSTMT * stmth, SQLUSMALLINT pos, int step)
 	else bufsize = sizeof(buf);
 
 	printf(">> readBlobAsChar field %d\n", pos);
-	while (rcode == SQL_SUCCESS_WITH_INFO) {
+	while (RetCode == SQL_SUCCESS_WITH_INFO) {
 		i++;
-		rcode = SQLGetData(stmth, pos, SQL_C_CHAR, (SQLPOINTER) buf, (SQLINTEGER) bufsize, &len);
-		if (!SQL_SUCCEEDED(rcode) || len <= 0)
+		CHKGetData(pos, SQL_C_CHAR, (SQLPOINTER) buf, (SQLINTEGER) bufsize, &len, "SINo");
+		if (RetCode == SQL_NO_DATA || len <= 0)
 			break;
 		if (len > (SQLLEN) bufsize)
 			len = (SQLLEN) bufsize - 1;
@@ -152,15 +151,16 @@ readBlobAsChar(SQLHSTMT * stmth, SQLUSMALLINT pos, int step)
 	printf(">>   total bytes read = %d \n", (int) total);
 	if (total != 20000)
 		failed = 1;
-	return rcode;
+	return RetCode;
 }
 
 
 int
 main(int argc, char **argv)
 {
-	SQLRETURN rcode;
+	SQLRETURN RetCode;
 	SQLHSTMT m_hstmt = NULL;
+	SQLHSTMT old_Statement = SQL_NULL_HSTMT;
 	int i;
 
 	int key;
@@ -183,15 +183,17 @@ main(int argc, char **argv)
 	for (i = 0; i < cnt; i++) {
 
 		m_hstmt = NULL;
-		CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &m_hstmt));
+		CHKAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt, "S");
+		old_Statement = Statement;
+		Statement = m_hstmt;
 
-		CHK(SQLPrepare, (m_hstmt, (SQLCHAR *) "INSERT INTO #tt VALUES ( ?, ?, ?, ?, ? )", SQL_NTS));
+		CHKPrepare((SQLCHAR *) "INSERT INTO #tt VALUES ( ?, ?, ?, ?, ? )", SQL_NTS, "S");
 
-		CHK(SQLBindParameter, (m_hstmt, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &key, 0, &vind0));
-		CHK(SQLBindParameter, (m_hstmt, 2, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARCHAR, 0x10000000, 0, buf1, 0, &vind1));
-		CHK(SQLBindParameter, (m_hstmt, 3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0x10000000, 0, buf2, 0, &vind2));
-		CHK(SQLBindParameter, (m_hstmt, 4, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARBINARY, 0x10000000, 0, buf3, 0, &vind3));
-		CHK(SQLBindParameter, (m_hstmt, 5, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &key, 0, &vind0));
+		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &key, 0, &vind0, "S");
+		CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARCHAR, 0x10000000, 0, buf1, 0, &vind1, "S");
+		CHKBindParameter(3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_LONGVARBINARY, 0x10000000, 0, buf2, 0, &vind2, "S");
+		CHKBindParameter(4, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARBINARY, 0x10000000, 0, buf3, 0, &vind3, "S");
+		CHKBindParameter(5, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &key, 0, &vind0, "S");
 
 		key = i;
 		vind0 = 0;
@@ -207,35 +209,33 @@ main(int argc, char **argv)
 		
 
 		printf(">> insert... %d\n", i);
-		rcode = SQLExecute(m_hstmt);
-		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "SQLExecute StmtH");
-		while (rcode == SQL_NEED_DATA) {
+		CHKR(SQLExecute, (m_hstmt), "SINe");
+		while (RetCode == SQL_NEED_DATA) {
 			char *p;
 
-			rcode = SQLParamData(m_hstmt, (SQLPOINTER) & p);
-			CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "SQLParamData StmtH");
-			printf(">> SQLParamData: ptr = %p  rcode = %d\n", (void *) p, rcode);
-			if (rcode == SQL_NEED_DATA) {
+			CHKR(SQLParamData, (m_hstmt, (SQLPOINTER) & p), "SINe");
+			printf(">> SQLParamData: ptr = %p  RetCode = %d\n", (void *) p, RetCode);
+			if (RetCode == SQL_NEED_DATA) {
 				if (p == buf3) {
 					fill_hex(buf3, NBYTES, 987, 25);
 					
-					CHK(SQLPutData, (m_hstmt, p, NBYTES - (i&1)));
+					CHKPutData(p, NBYTES - (i&1), "S");
 
 					printf(">> param %p: total bytes written = %d\n", (void *) p, NBYTES - (i&1));
 					
-					CHK(SQLPutData, (m_hstmt, p + NBYTES - (i&1), NBYTES + (i&1)));
+					CHKPutData(p + NBYTES - (i&1), NBYTES + (i&1), "S");
 
 					printf(">> param %p: total bytes written = %d\n", (void *) p, NBYTES + (i&1));
 				} else {
-					CHK(SQLPutData, (m_hstmt, p, NBYTES));
+					CHKPutData(p, NBYTES, "S");
 
 					printf(">> param %p: total bytes written = %d\n", (void *) p, NBYTES);
 				}
 			}
 		}
 
-		CHK(SQLFreeHandle, (SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt));
-
+		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt, "S");
+		Statement = old_Statement;
 	}
 
 	/* Now fetch rows ... */
@@ -244,39 +244,42 @@ main(int argc, char **argv)
 
 		m_hstmt = NULL;
 		CHK(SQLAllocHandle, (SQL_HANDLE_STMT, Connection, &m_hstmt));
+		old_Statement = Statement;
+		Statement = m_hstmt;
 
 		if (db_is_microsoft()) {
-			CHK(SQLSetStmtAttr, (m_hstmt, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER));
-			CHK(SQLSetStmtAttr, (m_hstmt, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER));
+			CHKSetStmtAttr(SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER, "S");
+			CHKSetStmtAttr(SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER, "S");
 		}
 
-		CHK(SQLPrepare, (m_hstmt, (SQLCHAR *) "SELECT t, b1, b2, v FROM #tt WHERE k = ?", SQL_NTS));
+		CHKPrepare((SQLCHAR *) "SELECT t, b1, b2, v FROM #tt WHERE k = ?", SQL_NTS, "S");
 
-		CHK(SQLBindParameter, (m_hstmt, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &i, 0, &vind0));
+		CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &i, 0, &vind0, "S");
 
-		CHK(SQLBindCol, (m_hstmt, 1, SQL_C_BINARY, NULL, 0, &vind1));
-		CHK(SQLBindCol, (m_hstmt, 2, SQL_C_BINARY, NULL, 0, &vind2));
-		CHK(SQLBindCol, (m_hstmt, 3, SQL_C_BINARY, NULL, 0, &vind3));
-		CHK(SQLBindCol, (m_hstmt, 4, SQL_C_LONG, &key, 0, &vind0));
+		CHKBindCol(1, SQL_C_BINARY, NULL, 0, &vind1, "S");
+		CHKBindCol(2, SQL_C_BINARY, NULL, 0, &vind2, "S");
+		CHKBindCol(3, SQL_C_BINARY, NULL, 0, &vind3, "S");
+		CHKBindCol(4, SQL_C_LONG, &key, 0, &vind0, "S");
 
 		vind0 = 0;
 		vind1 = SQL_DATA_AT_EXEC;
 		vind2 = SQL_DATA_AT_EXEC;
 
-		CHK(SQLExecute, (m_hstmt));
+		CHKExecute("S");
 
-		CHK(SQLFetchScroll, (m_hstmt, SQL_FETCH_NEXT, 0));
+		CHKFetchScroll(SQL_FETCH_NEXT, 0, "S");
 		printf(">> fetch... %d\n", i);
 
-		rcode = readBlob(m_hstmt, 1);
+		RetCode = readBlob(1);
 		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 1");
-		rcode = readBlob(m_hstmt, 2);
+		RetCode = readBlob(2);
 		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 2");
-		rcode = readBlobAsChar(m_hstmt, 3, i);
+		RetCode = readBlobAsChar(3, i);
 		CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt, "readBlob 3 as SQL_C_CHAR");
 
-		CHK(SQLCloseCursor, (m_hstmt));
-		CHK(SQLFreeHandle, (SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt));
+		CHKCloseCursor("S");
+		CHKFreeHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hstmt, "S");
+		Statement = old_Statement;
 	}
 
 	Disconnect();
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
index 7c421b3..2d2b543 100644
--- a/src/odbc/unittests/cancel.c
+++ b/src/odbc/unittests/cancel.c
@@ -45,8 +45,10 @@ exit_forced(int s)
 static void
 sigalrm_handler(int s)
 {
+	SQLRETURN RetCode;
+
 	printf(">>>> SQLCancel() ...\n");
-	CHK(SQLCancel, (Statement));
+	CHKCancel("S");
 	printf(">>>> ... SQLCancel done\n");
 
 	alarm(4);
@@ -56,7 +58,7 @@ sigalrm_handler(int s)
 int
 main(int argc, char **argv)
 {
-	SQLRETURN rcode;
+	SQLRETURN RetCode;
 
 	use_odbc_version3 = 1;
 	Connect();
@@ -64,19 +66,15 @@ main(int argc, char **argv)
 	printf(">> Wait 5 minutes...\n");
 	alarm(4);
 	signal(SIGALRM, sigalrm_handler);
-	rcode = SQLExecDirect(Statement, (SQLCHAR *) "WAITFOR DELAY '000:05:00'", SQL_NTS);
+	CHKExecDirect((SQLCHAR *) "WAITFOR DELAY '000:05:00'", SQL_NTS, "E");
 	alarm(0);
-	if (rcode != SQL_ERROR) {
-		fprintf(stderr, "SQLExecDirect should return error\n");
-		return 1;
-	}
 	getErrorInfo(SQL_HANDLE_STMT, Statement);
 	if (strcmp(sqlstate, "HY008") != 0) {
 		fprintf(stderr, "Unexpected sql state returned\n");
 		Disconnect();
 		return 1;
 	}
-	printf(">> ...  done rcode = %d\n", rcode);
+	printf(">> ...  done RetCode = %d\n", RetCode);
 
 	ResetStatement();
 
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index 00f2af3..2ae6150 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,12 +12,13 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.48 2008/10/31 14:00:11 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.49 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
 HDBC Connection;
 HSTMT Statement;
+SQLRETURN RetCode;
 int use_odbc_version3 = 0;
 void (*odbc_set_conn_attr)(void) = NULL;
 
@@ -394,3 +395,50 @@ CheckCursor(void)
 	ResetStatement();
 }
 
+SQLRETURN
+CheckRes(const char *file, int line, SQLRETURN rc, SQLSMALLINT handle_type, SQLHANDLE handle, const char *func, const char *res)
+{
+	const char *p = res;
+	for (;;) {
+		if (*p == 'S') {
+			if (rc == SQL_SUCCESS)
+				return rc;
+			++p;
+		} else if (*p == 'I') {
+			if (rc == SQL_SUCCESS_WITH_INFO)
+				return rc;
+			++p;
+		} else if (*p == 'E') {
+			if (rc == SQL_ERROR)
+				return rc;
+			++p;
+		} else if (strncmp(p, "No", 2) == 0) {
+			if (rc == SQL_NO_DATA)
+				return rc;
+			p += 2;
+		} else if (strncmp(p, "Ne", 2) == 0) {
+			if (rc == SQL_NEED_DATA)
+				return rc;
+			p += 2;
+		} else {
+			ReportError("Wrong results specified", line, file);
+			return rc;
+		}
+	}
+	ReportError(func, line, file);
+	return rc;
+}
+
+SQLSMALLINT
+AllocHandleErrType(SQLSMALLINT type)
+{
+	switch (type) {
+	case SQL_HANDLE_DESC:
+		return SQL_HANDLE_STMT;
+	case SQL_HANDLE_STMT:
+		return SQL_HANDLE_DBC;
+	case SQL_HANDLE_DBC:
+		return SQL_HANDLE_ENV;
+	}
+	return 0;
+}
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index bf4c174..3e6ac46 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.24 2008/10/29 09:33:50 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.25 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -36,6 +36,7 @@ static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_wa
 extern HENV Environment;
 extern HDBC Connection;
 extern HSTMT Statement;
+extern SQLRETURN RetCode;
 extern int use_odbc_version3;
 extern void (*odbc_set_conn_attr)(void);
 
@@ -59,10 +60,85 @@ void CheckCursor(void);
 #define ODBC_REPORT_ERROR(msg) ReportError(msg, __LINE__, __FILE__)
 
 #define CHK(func,params) \
-	do { if (func params != SQL_SUCCESS) \
+	do { if ((RetCode=(func params)) != SQL_SUCCESS) \
 		ODBC_REPORT_ERROR(#func); \
 	} while(0)
 
+SQLRETURN CheckRes(const char *file, int line, SQLRETURN rc, SQLSMALLINT handle_type, SQLHANDLE handle, const char *func, const char *res);
+#define CHKR(func, params, res) \
+	CheckRes(__FILE__, __LINE__, (RetCode=(func params)), 0, 0, #func, res)
+#define CHKR2(func, params, type, handle, res) \
+	CheckRes(__FILE__, __LINE__, (RetCode=(func params)), type, handle, #func, res)
+
+SQLSMALLINT AllocHandleErrType(SQLSMALLINT type);
+
+#define CHKAllocStmt(a,res) \
+	CHKR2(SQLAllocStmt, (Connection,a), SQL_HANDLE_DBC, Connection, res)
+#define CHKAllocHandle(a,b,c,res) \
+	CHKR2(SQLAllocHandle, (a,b,c), AllocHandleErrType(a), b, res)
+#define CHKBindCol(a,b,c,d,e,res) \
+	CHKR2(SQLBindCol, (Statement,a,b,c,d,e), SQL_HANDLE_STMT, Statement, res)
+#define CHKBindParameter(a,b,c,d,e,f,g,h,i,res) \
+	CHKR2(SQLBindParameter, (Statement,a,b,c,d,e,f,g,h,i), SQL_HANDLE_STMT, Statement, res)
+#define CHKCancel(res) \
+	CHKR2(SQLCancel, (Statement), SQL_HANDLE_STMT, Statement, res)
+#define CHKCloseCursor(res) \
+	CHKR2(SQLCloseCursor, (Statement), SQL_HANDLE_STMT, Statement, res)
+#define CHKColAttribute(a,b,c,d,e,f,res) \
+	CHKR2(SQLColAttribute, (Statement,a,b,c,d,e,f), SQL_HANDLE_STMT, Statement, res)
+#define CHKDescribeCol(a,b,c,d,e,f,g,h,res) \
+	CHKR2(SQLDescribeCol, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
+#define CHKEndTran(a,b,c,res) \
+	CHKR2(SQLEndTran, (a,b,c), a, b, res)
+#define CHKExecDirect(a,b,res) \
+	CHKR2(SQLExecDirect, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKExecute(res) \
+	CHKR2(SQLExecute, (Statement), SQL_HANDLE_STMT, Statement, res)
+#define CHKExtendedFetch(a,b,c,d,res) \
+	CHKR2(SQLExtendedFetch, (Statement,a,b,c,d), SQL_HANDLE_STMT, Statement, res)
+#define CHKFetch(res) \
+	CHKR2(SQLFetch, (Statement), SQL_HANDLE_STMT, Statement, res)
+#define CHKFetchScroll(a,b,res) \
+	CHKR2(SQLFetchScroll, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKFreeHandle(a,b,res) \
+	CHKR2(SQLFreeHandle, (a,b), a, b, res)
+#define CHKFreeStmt(a,res) \
+	CHKR2(SQLFreeStmt, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKGetConnectAttr(a,b,c,d,res) \
+	CHKR2(SQLGetConnectAttr, (Connection,a,b,c,d), SQL_HANDLE_DBC, Connection, res)
+#define CHKGetDiagRec(a,b,c,d,e,f,g,h,res) \
+	CHKR2(SQLGetDiagRec, (a,b,c,d,e,f,g,h), a, b, res)
+#define CHKGetStmtAttr(a,b,c,d,res) \
+	CHKR2(SQLGetStmtAttr, (Statement,a,b,c,d), SQL_HANDLE_STMT, Statement, res)
+#define CHKGetTypeInfo(a,res) \
+	CHKR2(SQLGetTypeInfo, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKGetData(a,b,c,d,e,res) \
+	CHKR2(SQLGetData, (Statement,a,b,c,d,e), SQL_HANDLE_STMT, Statement, res)
+#define CHKMoreResults(res) \
+	CHKR2(SQLMoreResults, (Statement), SQL_HANDLE_STMT, Statement, res)
+#define CHKNumResultCols(a,res) \
+	CHKR2(SQLNumResultCols, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKParamData(a,res) \
+	CHKR2(SQLParamData, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKPrepare(a,b,res) \
+	CHKR2(SQLPrepare, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKPutData(a,b,res) \
+	CHKR2(SQLPutData, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKRowCount(a,res) \
+	CHKR2(SQLRowCount, (Statement,a), SQL_HANDLE_STMT, Statement, res)
+#define CHKSetConnectAttr(a,b,c,res) \
+	CHKR2(SQLSetConnectAttr, (Connection,a,b,c), SQL_HANDLE_DBC, Connection, res)
+#define CHKSetCursorName(a,b,res) \
+	CHKR2(SQLSetCursorName, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKSetPos(a,b,c,res) \
+	CHKR2(SQLSetPos, (Statement,a,b,c), SQL_HANDLE_STMT, Statement, res)
+#define CHKSetStmtAttr(a,b,c,res) \
+	CHKR2(SQLSetStmtAttr, (Statement,a,b,c), SQL_HANDLE_STMT, Statement, res)
+#define CHKSetStmtOption(a,b,res) \
+	CHKR2(SQLSetStmtOption, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
+#define CHKTables(a,b,c,d,e,f,g,h,res) \
+	CHKR2(SQLTables, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
+
 int Connect(void);
 int Disconnect(void);
 void Command(HSTMT stmt, const char *command);
